// Generated by CoffeeScript 1.6.3
var fs, utils;

fs = require("fs");

utils = exports;

utils.trim = function(string) {
  return string.replace(/(^\s+)|(\s+$)/g, '');
};

utils.datedFileName = function(date) {
  if (date == null) {
    date = new Date;
  }
  return utils.formatDate("yy-mh-dd-hh-mn-ss");
};

utils.loggedDate = function(date) {
  if (date == null) {
    date = new Date;
  }
  return utils.formatDate("mh/dd hh:mn:ss", date);
};

utils.formatDate = function(format, date) {
  var dd, hh, mh, mn, ss, yy;
  if (date == null) {
    date = new Date;
  }
  yy = date.getFullYear();
  mh = date.getMonth() + 1;
  dd = date.getDate();
  hh = date.getHours();
  mn = date.getMinutes();
  ss = date.getSeconds();
  mh = utils.alignRight(mh, 2, "0");
  dd = utils.alignRight(dd, 2, "0");
  hh = utils.alignRight(hh, 2, "0");
  mn = utils.alignRight(mn, 2, "0");
  ss = utils.alignRight(ss, 2, "0");
  return format.replace("yy", yy).replace("mh", mh).replace("dd", dd).replace("hh", hh).replace("mn", mn).replace("ss", ss);
};

utils.alignLeft = function(string, length, pad) {
  if (pad == null) {
    pad = " ";
  }
  while (string.length < length) {
    string = "" + string + pad;
  }
  return string;
};

utils.alignRight = function(string, length, pad) {
  if (pad == null) {
    pad = " ";
  }
  string = "" + string;
  pad = "" + pad;
  while (string.length < length) {
    string = "" + pad + string;
  }
  return string;
};

utils.replaceTilde = function(fileName) {
  var tilde;
  tilde = process.env["HOME"] || process.env["USERPROFILE"] || '.';
  return fileName.replace('~', tilde);
};

utils.JL = function(object) {
  return JSON.stringify(object, null, 4);
};

utils.JS = function(object) {
  return JSON.stringify(object);
};
